/*
Dozen Days of Dice
Copyright (c) 2008 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.dozendays.dice
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;

	public class DiceContainer
	extends Sprite
	{
// ***** CONSTANTS **********************************************************
// ***** VARIABLES **********************************************************

		protected var _width:int; 
		protected var _height:int; 
		protected var _gap:int;
		protected var _dice:Array;

// ***** CONSTRUCTOR ********************************************************

		public function DiceContainer(
					w:int = 500, 
					h:int = 100, 
					gap:int = 5) 
		{
			_width = w;
			_height = h; 
			_gap = gap; 
			_dice = new Array();
		}
		
// ***** Functions - Getting and Setting ************************************

		public function clearDice():void
		{
			var temp:GenericDie;
			
			while (_dice.length > 0) {
				temp = _dice.pop();
				removeChild(temp);
			}
		}
		
		public function addDie(value:int):void
		{
			var temp:GenericDie = new GenericDie();
			temp.setValue(value);
			_dice.push(temp);
			addChild(temp);
			layout();
		}

// ***** Functions - Rendering **********************************************

		private function layout():void
		{
			var gaplessWidth:int = _width - _gap - _gap;
			var dieSize:int;
			var rows:int = 0;
			var dicePerRow:int;
			
			do {
				++rows;
				dieSize = (_height - _gap - (rows*_gap)) / rows;
				dicePerRow = gaplessWidth / (dieSize+_gap);
			} while ((dicePerRow * rows) < _dice.length);
			
			var colCount:int = 0;
			var rowCount:int = 0;
			for (var cntr:int = 0; cntr < _dice.length; ++cntr) {
				_dice[cntr].x = _gap + colCount * (dieSize+_gap);
				_dice[cntr].y = _gap + rowCount * (dieSize+_gap);
				_dice[cntr].width = dieSize;
				_dice[cntr].height = dieSize;
				++colCount;
				if (colCount >= dicePerRow) {
					++rowCount;
					colCount = 0;
				}
			}
		}
		
	}
}
